<?php


namespace Schaffen\Financial\FinancialMovement\Repositories;


use Freelabois\LaravelQuickstart\Extendables\Repository;
use Schaffen\Financial\FinancialMovement\Models\FinancialMovement;

class FinancialMovementRepository extends Repository
{
    protected $model = FinancialMovement::class;
    protected $searchableFields = [
        ["field" => "mvf_sentido"],
        ["field" => "mvf_numero_documento"],
        ["field" => "mvf_descricao", "operator" => "ilike"],
        ["field" => "mvf_dias_protesto"],
        ["field" => "mvf_multa"],
        ["field" => "mvf_juros"],
        ["field" => "mvf_tipo_juros"],
        ["field" => "mvf_fk_pes_codigo"],
        ["field" => "mvf_fk_pcg_codigo"],
        ["field" => "mvf_fk_ccu_codigo"],
        ["field" => "mvf_fk_tpg_codigo"],
        ["field" => "mvf_fk_his_codigo"],
        ["field" => "mvf_fk_mvf_codigo"],
        ["field" => "mvf_obs", "operator" => "ilike"],
        ["field" => "mvf_juros_adicionais"],
        ["field" => "mvf_status"],
        ["field" => "mvf_num_parcelas"],
        ["field" => "mvf_data_registro"],
        ["field" => "mvf_fk_fil_codigo"],
        ["field" => "mvf_fk_cep_codigo"],
        ["field" => "mvf_fk_cmf_codigo"],
        ["field" => "mvf_data_alteracao"],
        ["field" => "mvf_bloqueio_modulo"],
        ["field" => "mvf_usuario_alteracao"],
        ["field" => "mvf_usuario_registro"],
        ["field" => "mvf_codigo_barras"],
        ["field" => "mvf_fk_ent_codigo"],
        ["field" => "mvf_configuracao_cobranca"],
        ["field" => "mvf_admin"],
        ["field" => "mvf_fk_fop_codigo"],
        ["field" => "mvf_validada"],
        ["field" => "mvf_data_lancamento", "operator" => '>=', "name" => "mvf_data_lancamento_begin"],
        ["field" => "mvf_data_lancamento", "operator" => '>=', "name" => "mvf_data_lancamento_end"],
        ["field" => "mvf_status", "operator" => "in", "name" => "mvf_status_in"],
        ["field" => "mvf_fk_pes_codigo", "operator" => "in", "name" => "pes_codigo_in"],
    ];

    protected function applyCustomFilters()
    {
        $par_vencimento_end = null;

        extract($this->filters);

        $this->query->when($par_vencimento_end, function ($query) use($par_vencimento_end){
           return $query->whereHas('installment', function ($query) use($par_vencimento_end){
               return $query->where('par_data_vencimento_atual', '<=', $par_vencimento_end);
           }) ;
        });
    }
}